#!/usr/bin/python

"""
This file is part of Visuse.

Copyright (C) 2010 Jose Luis Lopez Pino jllopezpino@gmail.com

Visuse is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Visuse is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Visuse.  If not, see <http://www.gnu.org/licenses/>.

"""

from xml.dom import minidom
from classes import Resultado
import urllib


class YahooWeb(Resultado):
    def __init__(self, name, url, summary, rating, language, real_url):
        Resultado.__init__(self, name, url)
        self.summary = summary
        self.rating = rating
        self.language = language
        self.real_url = real_url


# Configuration
search_terms = "big bang theory"
api_key = 'ER6Og97V34FFUj.ttwezOZaA0QkI168zOWIolRp4N8MX3Ge3d.U17rxmPERH59WhQLlHUjHGmTT0udL3bxOm'


def PrintYahooWeb(listaResultados):
	for n in range(0, len(listaResultados)):
		print '=====', n, '====='
		print listaResultados[n].name
		print listaResultados[n].url
		print listaResultados[n].summary.encode("utf-8")
		print '\n'
	print 'endddd'
		
		
def SearchYahooWeb(search_terms):
	source = 'http://boss.yahooapis.com/ysearch/web/v1/' + urllib.quote_plus(search_terms) + '?appid=' + api_key + '&view=delicious_saves,language&format=xml'

	fichero = urllib.urlopen(source)

	XML = minidom.parse(fichero)
	listaFeed = XML.getElementsByTagName('result')
	resultList = []

	for n in range(0, len(listaFeed)):

		name = listaFeed[n].getElementsByTagName('title')[0].firstChild.data
		clickurl = listaFeed[n].getElementsByTagName('clickurl')[0].firstChild.data
		url = listaFeed[n].getElementsByTagName('url')[0].firstChild.data
		language = listaFeed[n].getElementsByTagName('language')[0].firstChild.data

		if( listaFeed[n].getElementsByTagName('abstract')[0].firstChild ):
			abstract = listaFeed[n].getElementsByTagName('abstract')[0].firstChild.data
		else:
			abstract = ''
			
		if( listaFeed[n].getElementsByTagName('delicious_saves')[0].firstChild ):
			delicious_saves = listaFeed[n].getElementsByTagName('delicious_saves')[0].firstChild.data
		else:
			delicious_saves = 0
			
		resultList.append(YahooWeb(name, clickurl, abstract, delicious_saves, language, url))

	#~ PrintYahooWeb(resultList)
		
	XML.unlink()
	
	return resultList;



